/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-20 19:08:55 UTC)
 * on 2013-06-25 at 02:06:15 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.sqladmin.model;

/**
 * Database instance backup configuration.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud SQL Administration API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BackupConfiguration extends com.google.api.client.json.GenericJson {

  /**
   * Whether this configuration is enabled.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean enabled;

  /**
   * Identifier for this configuration. This gets generated automatically when a backup
   * configuration is created.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * This is always sql#backupConfiguration.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Start time for the daily backup configuration in UTC timezone in the 24 hour format - HH:MM.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String startTime;

  /**
   * Whether this configuration is enabled.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getEnabled() {
    return enabled;
  }

  /**
   * Whether this configuration is enabled.
   * @param enabled enabled or {@code null} for none
   */
  public BackupConfiguration setEnabled(java.lang.Boolean enabled) {
    this.enabled = enabled;
    return this;
  }

  /**
   * Identifier for this configuration. This gets generated automatically when a backup
   * configuration is created.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Identifier for this configuration. This gets generated automatically when a backup
   * configuration is created.
   * @param id id or {@code null} for none
   */
  public BackupConfiguration setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * This is always sql#backupConfiguration.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * This is always sql#backupConfiguration.
   * @param kind kind or {@code null} for none
   */
  public BackupConfiguration setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Start time for the daily backup configuration in UTC timezone in the 24 hour format - HH:MM.
   * @return value or {@code null} for none
   */
  public java.lang.String getStartTime() {
    return startTime;
  }

  /**
   * Start time for the daily backup configuration in UTC timezone in the 24 hour format - HH:MM.
   * @param startTime startTime or {@code null} for none
   */
  public BackupConfiguration setStartTime(java.lang.String startTime) {
    this.startTime = startTime;
    return this;
  }

  @Override
  public BackupConfiguration set(String fieldName, Object value) {
    return (BackupConfiguration) super.set(fieldName, value);
  }

  @Override
  public BackupConfiguration clone() {
    return (BackupConfiguration) super.clone();
  }

}
